//+-------------------------------------------------------------------------------------------+
//|                                                                                           |
//|                                   SHI Channel MTF.mq4                                     |
//|                                                                                           |
//+-------------------------------------------------------------------------------------------+
#property copyright "Copyright  2004, Shurka & Kevin"
#property link      ""
/*---------------------------------------------------------------------------------------------
_v2:

New code for name assignment to labels.  Add code that allows the placement of channel change
"markers" to be turned off.  Add code to allow subordination of Channel Lines.  Some changes to 
external inputs for sake of clarity.
                                                                                - Traderathome
----------------------------------------------------------------------------------------------*/
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Yellow        //Channel Change Marker color
#property indicator_color2  CLR_NONE

//global extern inputs
extern bool    Indicator_On               = true;
extern string  note1                      = "0= uses TF number of open chart.";
extern string  note2                      = "1=M1  5=M5  15=M15  30=M30";
extern string  note3                      = "60=H1  240=H4  1440=D  10080=W"; 
extern int     ChannelLines_Per_TF_Number = 60;
extern int     ChannelLines_Thickness     = 1;
extern bool    Subordinate_ChannelLines   = true;
extern bool    Channel_ChangeMarkers_On   = false;
extern string  note5                      = "Channel length will be the input value";
extern string  note6                      = "or the maximum bars per chart, if less.";
extern int     BarsForChannel             = 300;
extern string  note7                      = "0= BarsForFractal value automated."; 
extern int     BarsForFractal             = 0;
extern color   M1_Channel_Color           = Turquoise;
extern color   M5_Channel_Color           = SteelBlue;
extern color   M15_Channel_Color          = Lime;
extern color   M30_Channel_Color          = Silver;
extern color   H1_Channel_Color           = Plum;
extern color   H4_Channel_Color           = DarkSlateBlue;
extern color   D_Channel_Color            = DarkOrange;
extern color   W_Channel_Color            = Red;

//global buffers and variables
double g_ibuf_88[];
int    gi_92       = 0;
double gd_96       = 0.0;
int    gi_104      = -1;  //used with start channel datetime
int    gi_108      = -1;
int    gi_112      = 0;
double g_price_116 = 0.0;
double g_price_124 = 0.0;
double g_price_132 = 0.0;
int    gi_140      = 0;
int    gi_144      = 300; //suggested bars for channel, or the bars on the chart if less
int    gi_148      = 0;   //BarsForFractal, value assigned in switch code
int    gi_152      = 0;
double gd_156      = 0.0;
int    g_datetime_164;    //final calculated start channel datetime
int    g_datetime_168;    //final calculated end channel dateime
color  g_color_172;       //variable for TF Channel color

//+-------------------------------------------------------------------------------------------+
//| Program Initialization                                                                    |
//+-------------------------------------------------------------------------------------------+
int init()
   {
   if (ChannelLines_Per_TF_Number == 0) {ChannelLines_Per_TF_Number = Period();}
   
   if(Channel_ChangeMarkers_On){
      SetIndexStyle(0, DRAW_ARROW);
      SetIndexArrow(0, 164);
      SetIndexBuffer(0, g_ibuf_88);
      SetIndexEmptyValue(0, 0.0);}
  
   return (0);
   }
     
//+-------------------------------------------------------------------------------------------+
//| Program De-initialization                                                                 |
//+-------------------------------------------------------------------------------------------+ 
int deinit()
   {
   int obj_total= ObjectsTotal(); 
   for (int i= obj_total; i>=0; i--){
      string name= ObjectName(i);   
      if (StringSubstr(name,0,8)=="[shiMTF]") {ObjectDelete(name);}}
   return (0);
   }

//+-------------------------------------------------------------------------------------------+
//| Program Start                                                                             |
//+-------------------------------------------------------------------------------------------+  
int start() 
   {
   deinit(); if (Indicator_On == false) {return(0);}
   int Timeframe = ChannelLines_Per_TF_Number;
   int li_unused_0 = IndicatorCounted();
   if (BarsForChannel == 0 || iBars(Symbol(), Timeframe) < BarsForChannel) {gi_144 = iBars(Symbol(), Timeframe);}
   else {gi_144 = BarsForChannel;}
   if (BarsForFractal > 0) {gi_148 = BarsForFractal;}
   else {
      switch (Timeframe) {      
      case PERIOD_M1:  gi_148 = 12; g_color_172 = M1_Channel_Color;  break;
      case PERIOD_M5:  gi_148 = 48; g_color_172 = M5_Channel_Color;  break;
      case PERIOD_M15: gi_148 = 24; g_color_172 = M15_Channel_Color; break;
      case PERIOD_M30: gi_148 = 24; g_color_172 = M30_Channel_Color; break;
      case PERIOD_H1:  gi_148 = 12; g_color_172 = H1_Channel_Color;  break;
      case PERIOD_H4:  gi_148 = 15; g_color_172 = H4_Channel_Color;  break;
      case PERIOD_D1:  gi_148 = 10; g_color_172 = D_Channel_Color;   break;
      case PERIOD_W1:  gi_148 = 6;  g_color_172 = W_Channel_Color;   break;
      default: deinit(); return (-1);}}
      
   gi_92 = 2; gi_104 = -1; gi_108 = -1; gi_112 = 0;
   while (gi_104 == -1 || gi_108 == -1 && gi_92 < gi_144) {
      if (gi_112 < 1 && gi_92 == iLowest(Symbol(), Timeframe, MODE_LOW, gi_148 << 1 + 1, gi_92 - gi_148)) {
         if (gi_112 == 0) {gi_112 = -1; gi_104 = gi_92; g_price_116 = iLow(Symbol(), Timeframe, gi_104);}
         else {gi_108 = gi_92; g_price_124 = iLow(Symbol(), Timeframe, gi_108);}}         
      if (gi_112 > -1 && gi_92 == iHighest(Symbol(), Timeframe, MODE_HIGH, gi_148 << 1 + 1, gi_92 - gi_148)) {
         if (gi_112 == 0) {gi_112 = 1; gi_104 = gi_92; g_price_116 = iHigh(Symbol(), Timeframe, gi_104);}
         else {gi_108 = gi_92; g_price_124 = iHigh(Symbol(), Timeframe, gi_108);}}
      gi_92++;}      
   if (gi_104 == -1 || gi_108 == -1) {deinit(); return (-1);}
   
   gd_96 = (g_price_124 - g_price_116) / (gi_108 - gi_104);
   g_price_116 -= gi_104 * gd_96; //interesting math here "... 116 -= ...."??
   gi_104 = 0; gi_152 = 0; gd_156 = 0;
   
   if (gi_112 == 1) {
      g_price_132 = iLow(Symbol(), Timeframe, 2) - 2.0 * gd_96;
      for (gi_140 = 3; gi_140 <= gi_108; gi_140++)
      if (iLow(Symbol(), Timeframe, gi_140) < g_price_132 + gd_96 * gi_140) {g_price_132 = iLow(Symbol(), Timeframe, gi_140) - gd_96 * gi_140;}
      if (iLow(Symbol(), Timeframe, 0) < g_price_132) {gi_152 = 0; gd_156 = g_price_132;}     
      if (iLow(Symbol(), Timeframe, 1) < g_price_132 + gd_96) {gi_152 = 1; gd_156 = g_price_132 + gd_96;}      
      if (iHigh(Symbol(), Timeframe, 0) > g_price_116) {gi_152 = 0; gd_156 = g_price_116;}      
      if (iHigh(Symbol(), Timeframe, 1) > g_price_116 + gd_96) {gi_152 = 1; gd_156 = g_price_116 + gd_96;}}
      
   else {
      g_price_132 = iHigh(Symbol(), Timeframe, 2) - 2.0 * gd_96;
      for (gi_140 = 3; gi_140 <= gi_108; gi_140++)
      if (iHigh(Symbol(), Timeframe, gi_140) > g_price_132 + gd_96 * gi_140) {g_price_132 = iHigh(Symbol(), Timeframe, gi_140) - gi_140 * gd_96;}
      if (iLow(Symbol(), Timeframe, 0) < g_price_116) {gi_152 = 0; gd_156 = g_price_116;}
      if (iLow(Symbol(), Timeframe, 1) < g_price_116 + gd_96) {gi_152 = 1; gd_156 = g_price_116 + gd_96;}
      if (iHigh(Symbol(), Timeframe, 0) > g_price_132) {gi_152 = 0; gd_156 = g_price_132;}
      if (iHigh(Symbol(), Timeframe, 1) > g_price_132 + gd_96) {gi_152 = 1; gd_156 = g_price_132 + gd_96;}}
      
   g_price_124 = g_price_116 + gi_144 * gd_96;
   g_datetime_164 = iTime(Symbol(), Timeframe, gi_104);
   g_datetime_168 = iTime(Symbol(), Timeframe, gi_144);
   if (gd_156 != 0.0) g_ibuf_88[gi_152] = gd_156; //value used for "arrow" placement- arrow draw removed from program
   deinit(); 
   string l_text_8 = " Channel size = " + DoubleToStr(MathAbs(g_price_132 - g_price_116) / Point, 0) + " Slope = " + DoubleToStr((-gd_96) / Point, 2);
   
   string name1= "[shiMTF] TL1_";
   string name2= "[shiMTF] TL2_";
   string name3= "[shiMTF] TL3_";
   
   //Draw upper TL
      ObjectCreate(name1 + Timeframe, OBJ_TREND, 0, g_datetime_168, g_price_132 + gd_96 * gi_144, g_datetime_164, g_price_132);
      ObjectSet(name1 + Timeframe, OBJPROP_COLOR, g_color_172);
      ObjectSet(name1 + Timeframe, OBJPROP_WIDTH, ChannelLines_Thickness);
      ObjectSet(name1 + Timeframe, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name1 + Timeframe,  OBJPROP_BACK,false);
      if(Subordinate_ChannelLines){
      ObjectSet(name1 + Timeframe,  OBJPROP_BACK,true);}      
      ObjectSetText(name1 + Timeframe, l_text_8);
      
   //Draw middle TL   
      ObjectCreate(name2 + Timeframe, OBJ_TREND, 0, g_datetime_168, (g_price_124 + g_price_132 + gd_96 * gi_144) / 2.0, g_datetime_164, (g_price_116 + g_price_132) / 2.0);
      ObjectSet(name2 + Timeframe, OBJPROP_COLOR, g_color_172);
      ObjectSet(name2 + Timeframe, OBJPROP_WIDTH, 1);
      ObjectSet(name2 + Timeframe, OBJPROP_STYLE, STYLE_DOT);
      ObjectSet(name2 + Timeframe,  OBJPROP_BACK,false);
      if(Subordinate_ChannelLines){
      ObjectSet(name2 + Timeframe,  OBJPROP_BACK,true);}
      ObjectSetText(name2 + Timeframe, l_text_8);   
      
   //Draw lower TL   
      ObjectCreate(name3 + Timeframe, OBJ_TREND, 0, g_datetime_168, g_price_124, g_datetime_164, g_price_116);
      ObjectSet(name3 + Timeframe, OBJPROP_COLOR, g_color_172);
      ObjectSet(name3 + Timeframe, OBJPROP_WIDTH, ChannelLines_Thickness);
      ObjectSet(name3 + Timeframe, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name3 + Timeframe,  OBJPROP_BACK,false);
      if(Subordinate_ChannelLines){
      ObjectSet(name3 + Timeframe,  OBJPROP_BACK,true);}
      ObjectSetText(name3 + Timeframe, l_text_8);
   
   return (0);
   }

//+-------------------------------------------------------------------------------------------+
//| Program End                                                                               |                                                        
//+-------------------------------------------------------------------------------------------+